Index: netwerk/cookie/src/nsCookieService.cpp
===================================================================
RCS file: /cvsroot/mozilla/netwerk/cookie/src/nsCookieService.cpp,v
retrieving revision 1.57
diff -p -U 8 -r1.57 nsCookieService.cpp
--- netwerk/cookie/src/nsCookieService.cpp	7 May 2007 11:14:01 -0000	1.57
+++ netwerk/cookie/src/nsCookieService.cpp	14 May 2007 09:24:21 -0000
@@ -811,483 +683,41 @@ nsCookieService::SetCookieStringFromHttp
   if (aServerTime && PR_ParseTimeString(aServerTime, PR_TRUE, &tempServerTime) == PR_SUCCESS) {
     serverTime = nsInt64(tempServerTime) / USEC_PER_SEC;
   } else {
     serverTime = NOW_IN_SECONDS;
   }
 
   // switch to a nice string type now, and process each cookie in the header
   nsDependentCString cookieHeader(aCookieHeader);
-  while (SetCookieInternal(aHostURI, aChannel,
+  while (SetCookieInternal(aContainer, aHostURI, aChannel,
                            cookieHeader, serverTime,
                            cookieStatus, cookiePolicy));
 
-  // write out the cookie file
-  LazyWrite();
   return NS_OK;
 }
 
-void
-nsCookieService::LazyWrite()
-{
-  if (mWriteTimer) {
-    mWriteTimer->SetDelay(kLazyWriteTimeout);
-  } else {
-    mWriteTimer = do_CreateInstance("@mozilla.org/timer;1");
-    if (mWriteTimer) {
-      mWriteTimer->InitWithFuncCallback(DoLazyWrite, this, kLazyWriteTimeout,
-                                        nsITimer::TYPE_ONE_SHOT);
-    }
-  }
-}
-
-void
-nsCookieService::DoLazyWrite(nsITimer *aTimer,
-                             void     *aClosure)
-{
-  nsCookieService *service = NS_REINTERPRET_CAST(nsCookieService*, aClosure);
-  service->Write();
-  service->mWriteTimer = 0;
-}
-
-// notify observers that a cookie was rejected due to the users' prefs.
-void
-nsCookieService::NotifyRejected(nsIURI *aHostURI)
-{
-  if (mObserverService)
-    mObserverService->NotifyObservers(aHostURI, "cookie-rejected", nsnull);
-}
-
-// notify observers that the cookie list changed. there are four possible
-// values for aData:
-// "deleted" means a cookie was deleted. aCookie is the deleted cookie.
-// "added"   means a cookie was added. aCookie is the added cookie.
-// "changed" means a cookie was altered. aCookie is the new cookie.
-// "cleared" means the entire cookie list was cleared. aCookie is null.
-void
-nsCookieService::NotifyChanged(nsICookie2      *aCookie,
-                               const PRUnichar *aData)
-{
-  mCookieChanged = PR_TRUE;
-
-  if (mObserverService)
-    mObserverService->NotifyObservers(aCookie, "cookie-changed", aData);
-
-  // fire a cookieIcon notification if the cookie was downgraded or flagged
-  // by p3p. the cookieIcon notification is now deprecated, but we still need
-  // this until consumers can be fixed. to see if cookies have been
-  // downgraded or flagged, listen to cookie-changed directly.
-  if (mCookiesPermissions == BEHAVIOR_P3P &&
-      (!nsCRT::strcmp(aData, NS_LITERAL_STRING("added").get()) ||
-       !nsCRT::strcmp(aData, NS_LITERAL_STRING("changed").get()))) {
-    nsCookieStatus status;
-    aCookie->GetStatus(&status);
-    if (status == nsICookie::STATUS_DOWNGRADED ||
-        status == nsICookie::STATUS_FLAGGED) {
-      mCookieIconVisible = PR_TRUE;
-      if (mObserverService)
-        mObserverService->NotifyObservers(nsnull, "cookieIcon", NS_LITERAL_STRING("on").get());
-    }
-  }
-}
-
 // this method is deprecated. listen to the cookie-changed notification instead.
 NS_IMETHODIMP
 nsCookieService::GetCookieIconIsVisible(PRBool *aIsVisible)
 {
   *aIsVisible = mCookieIconVisible;
   return NS_OK;
 }
 
 /******************************************************************************
- * nsCookieService:
- * pref observer impl
- ******************************************************************************/
-
-void
-nsCookieService::PrefChanged(nsIPrefBranch *aPrefBranch)
-{
-  PRInt32 val;
-  if (NS_SUCCEEDED(aPrefBranch->GetIntPref(kPrefCookiesPermissions, &val)))
-    mCookiesPermissions = LIMIT(val, 0, 3, 0);
-
-  if (NS_SUCCEEDED(aPrefBranch->GetIntPref(kPrefMaxNumberOfCookies, &val)))
-    mMaxNumberOfCookies = LIMIT(val, 0, 0xFFFF, 0xFFFF);
-
-  if (NS_SUCCEEDED(aPrefBranch->GetIntPref(kPrefMaxCookiesPerHost, &val)))
-    mMaxCookiesPerHost = LIMIT(val, 0, 0xFFFF, 0xFFFF);
-}
-
-/******************************************************************************
- * nsICookieManager impl:
- * nsICookieManager
- ******************************************************************************/
-
-NS_IMETHODIMP
-nsCookieService::RemoveAll()
-{
-  RemoveAllFromMemory();
-  NotifyChanged(nsnull, NS_LITERAL_STRING("cleared").get());
-  Write();
-  return NS_OK;
-}
-
-PR_STATIC_CALLBACK(PLDHashOperator)
-COMArrayCallback(nsCookieEntry *aEntry,
-                 void          *aArg)
-{
-  for (nsCookie *cookie = aEntry->Head(); cookie; cookie = cookie->Next()) {
-    NS_STATIC_CAST(nsCOMArray<nsICookie>*, aArg)->AppendObject(cookie);
-  }
-  return PL_DHASH_NEXT;
-}
-
-NS_IMETHODIMP
-nsCookieService::GetEnumerator(nsISimpleEnumerator **aEnumerator)
-{
-  RemoveExpiredCookies(NOW_IN_SECONDS);
-
-  nsCOMArray<nsICookie> cookieList(mCookieCount);
-  mHostTable.EnumerateEntries(COMArrayCallback, &cookieList);
-
-  return NS_NewArrayEnumerator(aEnumerator, cookieList);
-}
-
-NS_IMETHODIMP
-nsCookieService::Add(const nsACString &aDomain,
-                     const nsACString &aPath,
-                     const nsACString &aName,
-                     const nsACString &aValue,
-                     PRBool            aIsSecure,
-                     PRBool            aIsSession,
-                     PRInt64           aExpiry)
-{
-  nsInt64 currentTime = NOW_IN_SECONDS;
-
-  nsRefPtr<nsCookie> cookie =
-    nsCookie::Create(aName, aValue, aDomain, aPath,
-                     nsInt64(aExpiry),
-                     currentTime,
-                     aIsSession,
-                     aIsSecure,
-                     PR_FALSE,
-                     nsICookie::STATUS_UNKNOWN,
-                     nsICookie::POLICY_UNKNOWN);
-  if (!cookie) {
-    return NS_ERROR_OUT_OF_MEMORY;
-  }
-
-  AddInternal(cookie, currentTime, nsnull, nsnull);
-  return NS_OK;
-}
-
-NS_IMETHODIMP
-nsCookieService::Remove(const nsACString &aHost,
-                        const nsACString &aName,
-                        const nsACString &aPath,
-                        PRBool           aBlocked)
-{
-  nsListIter matchIter;
-  if (FindCookie(PromiseFlatCString(aHost),
-                 PromiseFlatCString(aName),
-                 PromiseFlatCString(aPath),
-                 matchIter)) {
-    nsRefPtr<nsCookie> cookie = matchIter.current;
-    RemoveCookieFromList(matchIter);
-    NotifyChanged(cookie, NS_LITERAL_STRING("deleted").get());
-
-    // check if we need to add the host to the permissions blacklist.
-    if (aBlocked && mPermissionService) {
-      nsCAutoString host(NS_LITERAL_CSTRING("http://") + cookie->RawHost());
-      nsCOMPtr<nsIURI> uri;
-      NS_NewURI(getter_AddRefs(uri), host);
-
-      if (uri)
-        mPermissionService->SetAccess(uri, nsICookiePermission::ACCESS_DENY);
-    }
-
-    LazyWrite();
-  }
-  return NS_OK;
-}
-
-/******************************************************************************
- * nsCookieService impl:
- * private file I/O functions
- ******************************************************************************/
-
-nsresult
-nsCookieService::Read()
-{
-  nsresult rv;
-  nsCOMPtr<nsIInputStream> fileInputStream;
-  rv = NS_NewLocalFileInputStream(getter_AddRefs(fileInputStream), mCookieFile);
-  if (NS_FAILED(rv)) {
-    return rv;
-  }
-
-  nsCOMPtr<nsILineInputStream> lineInputStream = do_QueryInterface(fileInputStream, &rv);
-  if (NS_FAILED(rv)) {
-    return rv;
-  }
-
-  static const char kTrue[] = "TRUE";
-
-  nsCAutoString buffer;
-  PRBool isMore = PR_TRUE;
-  PRInt32 hostIndex, isDomainIndex, pathIndex, secureIndex, expiresIndex, nameIndex, cookieIndex;
-  nsASingleFragmentCString::char_iterator iter;
-  PRInt32 numInts;
-  PRInt64 expires;
-  PRBool isDomain, isHttpOnly = PR_FALSE;
-  nsInt64 currentTime = NOW_IN_SECONDS;
-  // we use lastAccessedCounter to keep cookies in recently-used order,
-  // so we start by initializing to currentTime (somewhat arbitrary)
-  nsInt64 lastAccessedCounter = currentTime;
-  nsCookie *newCookie;
-
-  /* file format is:
-   *
-   * host \t isDomain \t path \t secure \t expires \t name \t cookie
-   *
-   * if this format isn't respected we move onto the next line in the file.
-   * isDomain is "TRUE" or "FALSE" (default to "FALSE")
-   * isSecure is "TRUE" or "FALSE" (default to "TRUE")
-   * expires is a PRInt64 integer
-   * note 1: cookie can contain tabs.
-   * note 2: cookies are written in order of lastAccessed time:
-   *         most-recently used come first; least-recently-used come last.
-   */
-
-  /*
-   * ...but due to bug 178933, we hide HttpOnly cookies from older code
-   * in a comment, so they don't expose HttpOnly cookies to JS.
-   *
-   * The format for HttpOnly cookies is
-   *
-   * #HttpOnly_host \t isDomain \t path \t secure \t expires \t name \t cookie
-   *
-   */
-
-  while (isMore && NS_SUCCEEDED(lineInputStream->ReadLine(buffer, &isMore))) {
-    if (StringBeginsWith(buffer, NS_LITERAL_CSTRING(kHttpOnlyPrefix))) {
-      isHttpOnly = PR_TRUE;
-      hostIndex = sizeof(kHttpOnlyPrefix) - 1;
-    } else if (buffer.IsEmpty() || buffer.First() == '#') {
-      continue;
-    } else {
-      isHttpOnly = PR_FALSE;
-      hostIndex = 0;
-    }
-
-    // this is a cheap, cheesy way of parsing a tab-delimited line into
-    // string indexes, which can be lopped off into substrings. just for
-    // purposes of obfuscation, it also checks that each token was found.
-    // todo: use iterators?
-    if ((isDomainIndex = buffer.FindChar('\t', hostIndex)     + 1) == 0 ||
-        (pathIndex     = buffer.FindChar('\t', isDomainIndex) + 1) == 0 ||
-        (secureIndex   = buffer.FindChar('\t', pathIndex)     + 1) == 0 ||
-        (expiresIndex  = buffer.FindChar('\t', secureIndex)   + 1) == 0 ||
-        (nameIndex     = buffer.FindChar('\t', expiresIndex)  + 1) == 0 ||
-        (cookieIndex   = buffer.FindChar('\t', nameIndex)     + 1) == 0) {
-      continue;
-    }
-
-    // check the expirytime first - if it's expired, ignore
-    // nullstomp the trailing tab, to avoid copying the string
-    buffer.BeginWriting(iter);
-    *(iter += nameIndex - 1) = char(0);
-    numInts = PR_sscanf(buffer.get() + expiresIndex, "%lld", &expires);
-    if (numInts != 1 || nsInt64(expires) < currentTime) {
-      continue;
-    }
-
-    isDomain = Substring(buffer, isDomainIndex, pathIndex - isDomainIndex - 1)
-               .EqualsLiteral(kTrue);
-    const nsASingleFragmentCString &host = Substring(buffer, hostIndex, isDomainIndex - hostIndex - 1);
-    // check for bad legacy cookies (domain not starting with a dot, or containing a port),
-    // and discard
-    if (isDomain && !host.IsEmpty() && host.First() != '.' ||
-        host.FindChar(':') != kNotFound) {
-      continue;
-    }
-
-    // create a new nsCookie and assign the data.
-    newCookie =
-      nsCookie::Create(Substring(buffer, nameIndex, cookieIndex - nameIndex - 1),
-                       Substring(buffer, cookieIndex, buffer.Length() - cookieIndex),
-                       host,
-                       Substring(buffer, pathIndex, secureIndex - pathIndex - 1),
-                       nsInt64(expires),
-                       lastAccessedCounter,
-                       PR_FALSE,
-                       Substring(buffer, secureIndex, expiresIndex - secureIndex - 1).EqualsLiteral(kTrue),
-                       isHttpOnly,
-                       nsICookie::STATUS_UNKNOWN,
-                       nsICookie::POLICY_UNKNOWN);
-    if (!newCookie) {
-      return NS_ERROR_OUT_OF_MEMORY;
-    }
-
-    // trick: keep the cookies in most-recently-used order,
-    // by successively decrementing the lastAccessed time
-    lastAccessedCounter -= nsInt64(1);
-
-    if (!AddCookieToList(newCookie)) {
-      // It is purpose that created us; purpose that connects us;
-      // purpose that pulls us; that guides us; that drives us.
-      // It is purpose that defines us; purpose that binds us.
-      // When a cookie no longer has purpose, it has a choice:
-      // it can return to the source to be deleted, or it can go
-      // into exile, and stay hidden inside the Matrix.
-      // Let's choose deletion.
-      delete newCookie;
-    }
-  }
-
-  mCookieChanged = PR_FALSE;
-  return NS_OK;
-}
-
-PR_STATIC_CALLBACK(PLDHashOperator)
-cookieListCallback(nsCookieEntry *aEntry,
-                   void          *aArg)
-{
-  for (nsCookie *cookie = aEntry->Head(); cookie; cookie = cookie->Next()) {
-    NS_STATIC_CAST(nsVoidArray*, aArg)->AppendElement(cookie);
-  }
-  return PL_DHASH_NEXT;
-}
-
-nsresult
-nsCookieService::Write()
-{
-  if (!mCookieChanged) {
-    return NS_OK;
-  }
-
-  if (!mCookieFile) {
-    return NS_ERROR_NULL_POINTER;
-  }
-
-  nsresult rv;
-  nsCOMPtr<nsIOutputStream> fileOutputStream;
-  rv = NS_NewSafeLocalFileOutputStream(getter_AddRefs(fileOutputStream),
-                                       mCookieFile,
-                                       -1,
-                                       0600);
-  if (NS_FAILED(rv)) {
-    NS_ERROR("failed to open cookies.txt for writing");
-    return rv;
-  }
-
-  // get a buffered output stream 4096 bytes big, to optimize writes
-  nsCOMPtr<nsIOutputStream> bufferedOutputStream;
-  rv = NS_NewBufferedOutputStream(getter_AddRefs(bufferedOutputStream), fileOutputStream, 4096);
-  if (NS_FAILED(rv)) {
-    return rv;
-  }
-
-  static const char kHeader[] =
-      "# HTTP Cookie File\n"
-      "# http://wp.netscape.com/newsref/std/cookie_spec.html\n"
-      "# This is a generated file!  Do not edit.\n"
-      "# To delete cookies, use the Cookie Manager.\n\n";
-  // note: kTrue and kFalse have leading/trailing tabs already added
-  static const char kTrue[] = "\tTRUE\t";
-  static const char kFalse[] = "\tFALSE\t";
-  static const char kTab[] = "\t";
-  static const char kNew[] = "\n";
-
-  // create a new nsVoidArray to hold the cookie list, and sort it
-  // such that least-recently-used cookies come last
-  nsVoidArray sortedCookieList(mCookieCount);
-  mHostTable.EnumerateEntries(cookieListCallback, &sortedCookieList);
-  sortedCookieList.Sort(compareCookiesForWriting, nsnull);
-
-  bufferedOutputStream->Write(kHeader, sizeof(kHeader) - 1, &rv);
-
-  /* file format is:
-   *
-   * host \t isDomain \t path \t secure \t expires \t name \t cookie
-   *
-   * isDomain is "TRUE" or "FALSE"
-   * isSecure is "TRUE" or "FALSE"
-   * expires is a PRInt64 integer
-   * note 1: cookie can contain tabs.
-   * note 2: cookies are written in order of lastAccessed time:
-   *         most-recently used come first; least-recently-used come last.
-   */
-
-  /*
-   * XXX but see above in ::Read for the HttpOnly hack
-   */
-   
-  nsCookie *cookie;
-  nsInt64 currentTime = NOW_IN_SECONDS;
-  char dateString[22];
-  PRUint32 dateLen;
-  for (PRUint32 i = 0; i < mCookieCount; ++i) {
-    cookie = NS_STATIC_CAST(nsCookie*, sortedCookieList.ElementAt(i));
-
-    // don't write entry if cookie has expired, or is a session cookie
-    if (cookie->IsSession() || cookie->Expiry() <= currentTime) {
-      continue;
-    }
-
-    // XXX hack for HttpOnly. see bug 178993.
-    if (cookie->IsHttpOnly()) {
-      bufferedOutputStream->Write(kHttpOnlyPrefix, sizeof(kHttpOnlyPrefix) - 1, &rv);
-    }
-    bufferedOutputStream->Write(cookie->Host().get(), cookie->Host().Length(), &rv);
-    if (cookie->IsDomain()) {
-      bufferedOutputStream->Write(kTrue, sizeof(kTrue) - 1, &rv);
-    } else {
-      bufferedOutputStream->Write(kFalse, sizeof(kFalse) - 1, &rv);
-    }
-    bufferedOutputStream->Write(cookie->Path().get(), cookie->Path().Length(), &rv);
-    if (cookie->IsSecure()) {
-      bufferedOutputStream->Write(kTrue, sizeof(kTrue) - 1, &rv);
-    } else {
-      bufferedOutputStream->Write(kFalse, sizeof(kFalse) - 1, &rv);
-    }
-    dateLen = PR_snprintf(dateString, sizeof(dateString), "%lld", PRInt64(cookie->Expiry()));
-    bufferedOutputStream->Write(dateString, dateLen, &rv);
-    bufferedOutputStream->Write(kTab, sizeof(kTab) - 1, &rv);
-    bufferedOutputStream->Write(cookie->Name().get(), cookie->Name().Length(), &rv);
-    bufferedOutputStream->Write(kTab, sizeof(kTab) - 1, &rv);
-    bufferedOutputStream->Write(cookie->Value().get(), cookie->Value().Length(), &rv);
-    bufferedOutputStream->Write(kNew, sizeof(kNew) - 1, &rv);
-  }
-
-  // All went ok. Maybe except for problems in Write(), but the stream detects
-  // that for us
-  nsCOMPtr<nsISafeOutputStream> safeStream = do_QueryInterface(bufferedOutputStream);
-  NS_ASSERTION(safeStream, "expected a safe output stream!");
-  if (safeStream) {
-    rv = safeStream->Finish();
-    if (NS_FAILED(rv)) {
-      NS_WARNING("failed to save cookie file! possible dataloss");
-      return rv;
-    }
-  }
-
-  mCookieChanged = PR_FALSE;
-  return NS_OK;
-}
-
-/******************************************************************************
  * nsCookieService impl:
  * private GetCookie/SetCookie helpers
  ******************************************************************************/
 
 // processes a single cookie, and returns PR_TRUE if there are more cookies
 // to be processed
 PRBool
-nsCookieService::SetCookieInternal(nsIURI             *aHostURI,
+nsCookieService::SetCookieInternal(nsICookieContainer *aContainer,
+                                   nsIURI             *aHostURI,
                                    nsIChannel         *aChannel,
                                    nsDependentCString &aCookieHeader,
                                    nsInt64             aServerTime,
                                    nsCookieStatus      aStatus,
                                    nsCookiePolicy      aPolicy)
 {
   // create a stack-based nsCookieAttributes, to store all the
   // attributes parsed from the cookie
@@ -1305,24 +735,25 @@ nsCookieService::SetCookieInternal(nsIUR
   const PRBool newCookie = ParseAttributes(aCookieHeader, cookieAttributes);
 
   // calculate expiry time of cookie. we need to pass in cookieStatus, since
   // the cookie may have been downgraded to a session cookie by p3p.
   const nsInt64 currentTime = NOW_IN_SECONDS;
   cookieAttributes.isSession = GetExpiry(cookieAttributes, aServerTime,
                                          currentTime, aStatus);
 
-  CheckAndAdd(aHostURI, aChannel, cookieAttributes,
+  CheckAndAdd(aContainer, aHostURI, aChannel, cookieAttributes,
               aStatus, aPolicy, savedCookieHeader);
 
   return newCookie;
 }
 
 void
-nsCookieService::CheckAndAdd(nsIURI               *aHostURI,
+nsCookieService::CheckAndAdd(nsICookieContainer   *aContainer,
+                             nsIURI               *aHostURI,
                              nsIChannel           *aChannel,
                              nsCookieAttributes   &aAttributes,
                              nsCookieStatus        aStatus,
                              const nsCookiePolicy  aPolicy,
                              const nsAFlatCString &aCookieHeader)
 {
   // reject cookie if it's over the size limit, per RFC2109
   if ((aAttributes.name.Length() + aAttributes.value.Length()) > kMaxBytesPerCookie) {
@@ -1361,112 +792,46 @@ nsCookieService::CheckAndAdd(nsIURI     
                      aStatus,
                      aPolicy);
   if (!cookie) {
     return;
   }
 
   // check permissions from site permission list, or ask the user,
   // to determine if we can set the cookie
-  if (mPermissionService) {
+  nsCOMPtr<nsICookiePermission> permissionService = do_QueryInterface(aContainer);
+  if (!permissionService)
+    permissionService = mPermissionService;
+
+  if (permissionService) {
     PRBool permission;
     // we need to think about prompters/parent windows here - TestPermission
     // needs one to prompt, so right now it has to fend for itself to get one
-    mPermissionService->CanSetCookie(aHostURI,
+    permissionService->CanSetCookie(aHostURI,
                                      aChannel,
                                      NS_STATIC_CAST(nsICookie2*, NS_STATIC_CAST(nsCookie*, cookie)),
                                      &aAttributes.isSession,
                                      &aAttributes.expiryTime.mValue,
                                      &permission);
     if (!permission) {
       COOKIE_LOGFAILURE(SET_COOKIE, aHostURI, aCookieHeader, "cookie rejected by permission manager");
-      NotifyRejected(aHostURI);
+      char *cid;
+      aContainer->GetContainerId(&cid);
+      NotifyRejected(aHostURI, NS_ConvertASCIItoUTF16(cid).get());
+      nsMemory::Free(cid);
       return;
     }
 
     // update isSession and expiry attributes, in case they changed
     cookie->SetIsSession(aAttributes.isSession);
     cookie->SetExpiry(aAttributes.expiryTime);
   }
 
-  // add the cookie to the list. AddInternal() takes care of logging.
-  AddInternal(cookie, NOW_IN_SECONDS, aHostURI, aCookieHeader.get());
-}
-
-// this is a backend function for adding a cookie to the list, via SetCookie.
-// also used in the cookie manager, for profile migration from IE.
-// it either replaces an existing cookie; or adds the cookie to the hashtable,
-// and deletes a cookie (if maximum number of cookies has been
-// reached). also performs list maintenance by removing expired cookies.
-void
-nsCookieService::AddInternal(nsCookie   *aCookie,
-                             nsInt64    aCurrentTime,
-                             nsIURI     *aHostURI,
-                             const char *aCookieHeader)
-{
-  nsListIter matchIter;
-  const PRBool foundCookie =
-    FindCookie(aCookie->Host(), aCookie->Name(), aCookie->Path(), matchIter);
-
-  nsRefPtr<nsCookie> oldCookie;
-  if (foundCookie) {
-    oldCookie = matchIter.current;
-    RemoveCookieFromList(matchIter);
-
-    // check if the cookie has expired
-    if (aCookie->Expiry() <= aCurrentTime) {
-      COOKIE_LOGFAILURE(SET_COOKIE, aHostURI, aCookieHeader, "previously stored cookie was deleted");
-      NotifyChanged(oldCookie, NS_LITERAL_STRING("deleted").get());
-      return;
-    }
-
-    // preserve creation time of cookie
-    if (oldCookie) {
-      aCookie->SetCreationTime(oldCookie->CreationTime());
-    }
-
-  } else {
-    // check if cookie has already expired
-    if (aCookie->Expiry() <= aCurrentTime) {
-      COOKIE_LOGFAILURE(SET_COOKIE, aHostURI, aCookieHeader, "cookie has already expired");
-      return;
-    }
-
-    // check if we have to delete an old cookie.
-    nsEnumerationData data(aCurrentTime, LL_MAXINT);
-    if (CountCookiesFromHostInternal(aCookie->RawHost(), data) >= mMaxCookiesPerHost) {
-      // remove the oldest cookie from host
-      oldCookie = data.iter.current;
-      RemoveCookieFromList(data.iter);
-
-    } else if (mCookieCount >= mMaxNumberOfCookies) {
-      // try to make room, by removing expired cookies
-      RemoveExpiredCookies(aCurrentTime);
-
-      // check if we still have to get rid of something
-      if (mCookieCount >= mMaxNumberOfCookies) {
-        // find the position of the oldest cookie, and remove it
-        data.oldestTime = LL_MAXINT;
-        FindOldestCookie(data);
-        oldCookie = data.iter.current;
-        RemoveCookieFromList(data.iter);
-      }
-    }
-
-    // if we deleted an old cookie, notify consumers
-    if (oldCookie)
-      NotifyChanged(oldCookie, NS_LITERAL_STRING("deleted").get());
-  }
-
-  // add the cookie to head of list
-  AddCookieToList(aCookie);
-  NotifyChanged(aCookie, foundCookie ? NS_LITERAL_STRING("changed").get()
-                                     : NS_LITERAL_STRING("added").get());
-
-  COOKIE_LOGSUCCESS(SET_COOKIE, aHostURI, aCookieHeader, aCookie);
+  // add the cookie to the container
+  aContainer->SetCookie(aHostURI, cookie);
 }
 
 /******************************************************************************
  * nsCookieService impl:
  * private cookie header parsing functions
  ******************************************************************************/
 
 // The following comment block elucidates the function of ParseAttributes.
@@ -1708,16 +1073,74 @@ nsCookieService::ParseAttributes(nsDepen
       aCookieAttributes.isHttpOnly = PR_TRUE;
   }
 
   // rebind aCookieHeader, in case we need to process another cookie
   aCookieHeader.Rebind(cookieStart, cookieEnd);
   return newCookie;
 }
 
+PRBool
+nsCookieService::GetExpiry(nsCookieAttributes &aCookieAttributes,
+                           nsInt64            aServerTime,
+                           nsInt64            aCurrentTime,
+                           nsCookieStatus     aStatus)
+{
+  /* Determine when the cookie should expire. This is done by taking the difference between 
+   * the server time and the time the server wants the cookie to expire, and adding that 
+   * difference to the client time. This localizes the client time regardless of whether or
+   * not the TZ environment variable was set on the client.
+   *
+   * Note: We need to consider accounting for network lag here, per RFC.
+   */
+  nsInt64 delta;
+
+  // check for max-age attribute first; this overrides expires attribute
+  if (!aCookieAttributes.maxage.IsEmpty()) {
+    // obtain numeric value of maxageAttribute
+    PRInt64 maxage;
+    PRInt32 numInts = PR_sscanf(aCookieAttributes.maxage.get(), "%lld", &maxage);
+
+    // default to session cookie if the conversion failed
+    if (numInts != 1) {
+      return PR_TRUE;
+    }
+
+    delta = nsInt64(maxage);
+
+  // check for expires attribute
+  } else if (!aCookieAttributes.expires.IsEmpty()) {
+    nsInt64 expires;
+    PRTime tempExpires;
+
+    // parse expiry time
+    if (PR_ParseTimeString(aCookieAttributes.expires.get(), PR_TRUE, &tempExpires) == PR_SUCCESS) {
+      expires = nsInt64(tempExpires) / USEC_PER_SEC;
+    } else {
+      return PR_TRUE;
+    }
+
+    delta = expires - aServerTime;
+
+  // default to session cookie if no attributes found
+  } else {
+    return PR_TRUE;
+  }
+
+  // if this addition overflows, expiryTime will be less than currentTime
+  // and the cookie will be expired - that's okay.
+  aCookieAttributes.expiryTime = aCurrentTime + delta;
+
+  // we need to return whether the cookie is a session cookie or not:
+  // the cookie may have been previously downgraded by p3p prefs,
+  // so we take that into account here. only applies to non-expired cookies.
+  return aStatus == nsICookie::STATUS_DOWNGRADED &&
+         aCookieAttributes.expiryTime > aCurrentTime;
+}
+
 /******************************************************************************
  * nsCookieService impl:
  * private domain & permission compliance enforcement functions
  ******************************************************************************/
 
 // returns PR_TRUE if aHost is an IP address
 PRBool
 nsCookieService::IsIPAddress(const nsAFlatCString &aHost)
@@ -1828,17 +1251,18 @@ nsCookieService::IsForeign(nsIURI *aHost
   }
 
   // don't have enough dots to chop firstHost, or the subdomain levels differ;
   // so we just do the plain old check, IsInDomain(firstHost, currentHost).
   return !IsInDomain(NS_LITERAL_CSTRING(".") + firstHost, currentHost);
 }
 
 nsCookieStatus
-nsCookieService::CheckPrefs(nsIURI         *aHostURI,
+nsCookieService::CheckPrefs(nsICookiePermission *aPermissionService,
+                            nsIURI         *aHostURI,
                             nsIURI         *aFirstURI,
                             nsIChannel     *aChannel,
                             const char     *aCookieHeader,
                             nsCookiePolicy &aPolicy)
 {
   // pref tree:
   // 0) get the scheme strings from the two URI's
   // 1) disallow ftp
@@ -1870,19 +1294,19 @@ nsCookieService::CheckPrefs(nsIURI      
   // don't let ftp sites get/set cookies (could be a security issue)
   if (currentURIScheme.EqualsLiteral("ftp")) {
     COOKIE_LOGFAILURE(aCookieHeader ? SET_COOKIE : GET_COOKIE, aHostURI, aCookieHeader, "ftp sites cannot read cookies");
     return STATUS_REJECTED_WITH_ERROR;
   }
 
   // check the permission list first; if we find an entry, it overrides
   // default prefs. see bug 184059.
-  if (mPermissionService) {
+  if (aPermissionService) {
     nsCookieAccess access;
-    rv = mPermissionService->CanAccess(aHostURI, aFirstURI, aChannel, &access);
+    rv = aPermissionService->CanAccess(aHostURI, aFirstURI, aChannel, &access);
 
     // if we found an entry, use it
     if (NS_SUCCEEDED(rv)) {
       switch (access) {
       case nsICookiePermission::ACCESS_DENY:
         COOKIE_LOGFAILURE(aCookieHeader ? SET_COOKIE : GET_COOKIE, aHostURI, aCookieHeader, "cookies are blocked for this site");
         return nsICookie::STATUS_REJECTED;
 
